%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 
% FI:PA171 - Digital Filters
%
% topic: 2D-DFT & Sampling
% author: David Svoboda 
%         Masaryk University (c) 2019
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%-------------------------
% FT-separability
%-------------------------

% Check that 2D-DFT is separable:
% some 2x2 matrix
A = [1 2; 3 4]
% FFT along x-axis
Fx = [fft(A(1,:)); fft(A(2,:))]
% FFT along y-axis following FFT along x-axis
Fxy = [fft(Fx(:,1)) fft(Fx(:,2))]
% full 2D FFT
fft2(A)
 
%------------------------------------------------------------------
% Task A: Implement Fast Fourier transform in 2D. You can use the
% 'my_fft' function from the previous seminar. Assume that the image 
% size is 2^M by 2^N.
%------------------------------------------------------------------
function vysledek = my_fft2(vstup);

%------------------------------------------------------------------
% Task B: Built MIPmap pyramid. The input is the RGB image and the 
% number of levels. The output is the pyramid in the condesed form,
% where the memory usage is minimized. The individual color channels
% are stored separately. The red one is stored in diagonal direction.
% The green one is stored from top to bottom. The blue one stored along
% ther bottom line. See the sample images 'input.tif' and 'output.tif'.
%------------------------------------------------------------------
function vysledek = mipmap(RGBobrazek, pocet);
